--[[
Lua Consoleから

callEvent("イベントの名前")

でLuaのスクリプトを呼び出せる

]]--

App.Home = App.Home or {
	stateWillEnter = function(self)

		PrintLog("stateWillEnter:Home")

	end,
	--homeに入った際の処理
	OnEnterToHome = function(self,from,exp,level,yamadaFunctions)
		PrintLog("home OnEnterToHome:"..from)

		--どこから来たか参照させる。
 		EventSequenceParams.from = from

		if from == "" then
			
			--レベル1の時は、最大経験値をtableから参照し設定しておく
			local level = tonumber(ExecuteBridgeGetStringByName( "PlayerParams.level" ))
			if level == 1 then
				local levelTbl = LevelTables[1]
				ExecuteBridgeSetIntByName( "PlayerParams.maxExp", levelTbl.nextExp )
			end

			DispatchEvent("RoomEvent.RoomEvent_INIT")

		else
			--タイトル以外の遷移の場合
			if level == "" then
				EventSequenceParams.level = 0
			else
				EventSequenceParams.level = tonumber(level)
			end
			
			EventSequenceParams.exp = exp
			EventSequenceParams.yamadafunctions = split(yamadaFunctions, ",")

			ExcuteResetMessageWindowPosition()

			if from == "bigreward" then
				DispatchEvent("RoomRewordEvent.RoomRewordEvent_Big")
			elseif from == "middlereward" then
				DispatchEvent("RoomRewordEvent.RoomRewordEvent_Middle")
			else
				DispatchEvent("RoomRewordEvent.RoomRewordEvent_Small")
			end
		end

	end,

	--メインメニューを開いた際の遷移
	OnEnterMainMenu = function(self)
		changeSubState( self, "MainMenu" )
	end,

	OnTestEvent = function(self)
		PrintLog("Home OnTestEvent:ok"..getFullStatePath())
	end,

	OnClearSubState = function(self)
		clearSubState(self);
	end
}

-- イベント事前判定用（※リワード画面の初期化タイミング／タイトルからのルーム遷移等で呼ばれる）
-- この処理は、[App.Home.OnEnterToHome]に先立ってよばれる
ReserveEventForReward = function( rewardType, addExp, strLevel )
	EventSequenceParams.from = rewardType
	EventSequenceParams.exp = addExp

	-- -------------------------------------------------------------------------------------
	-- ボス出現フラグオフ予約
	-- ダンジョン中にフラグのオン／オフをしてしまうと、サスペンドリジュームで不具合がでるため、
	-- ダンジョン中ではボスを倒した予約フラグのみ立てておき、そのフラグによりリワード画面で実フラグを寝かす
	-- -------------------------------------------------------------------------------------
	if rewardType == "bigreward" then	-- 用心（※ビッグリワードでなければ無視）
		if FlagGetB( "reserve_boss_appear_kaityo_off" )   then		FlagSetB( "boss_appear_kaityo", false );	end
		if FlagGetB( "reserve_boss_appear_komebitu_off" ) then		FlagSetB( "boss_appear_komebitu", false );	end
		if FlagGetB( "reserve_boss_appear_masamune_off" ) then		FlagSetB( "boss_appear_masamune", false );	end
		if FlagGetB( "reserve_boss_appear_baibai_off" )   then		FlagSetB( "boss_appear_baibai", false );	end
		if FlagGetB( "reserve_boss_appear_maou_off" )     then		FlagSetB( "boss_appear_maou", false );		end
		if FlagGetB( "reserve_boss_appear_maoubird_off" ) then		FlagSetB( "boss_appear_maoubird", false );	end
	end
	-- 魔王城をクリアしてきた
	FlagSetB( "boss_not_appear_BossKaityo_A", false )

	-- 毎回フラグオフ（※ボスを倒した瞬間に「ゲームを中断→再プレイ→ゲームオーバー」への用心）
	FlagSetB( "reserve_boss_appear_kaityo_off", nil )
	FlagSetB( "reserve_boss_appear_komebitu_off", nil )
	FlagSetB( "reserve_boss_appear_masamune_off", nil )
	FlagSetB( "reserve_boss_appear_baibai_off", nil )
	FlagSetB( "reserve_boss_appear_maou_off", nil )
	FlagSetB( "reserve_boss_appear_maoubird_off", nil )
	-- -------------------------------------------------------------------------------------

	if strLevel == "" then
		EventSequenceParams.level = 0
	else
		EventSequenceParams.level = tonumber(strLevel)
	end

	if rewardType == "bigreward" then
		RoomRewordEvent.ReserveFor_RoomRewordEvent_Big()
	elseif rewardType == "middlereward" then
		RoomRewordEvent.ReserveFor_RoomRewordEvent_Middle()
	else
		RoomRewordEvent.ReserveFor_RoomRewordEvent_Small()
	end
end

--------------------------------
-- メインメニュー
--------------------------------
App.Home.MainMenu = {
	stateWillEnter = function(self)	
		PrintLog("stateWillEnter:MainMenu")
	end,

	--ダンジョンのリストを開いた際の遷移
	OnEnterSubMenuDungeonSelect = function(self)
		changeSubState( self, "SubMenuDungeonSelect" )
	end,

	--倉庫を開いた際の遷移
	OnEnterSubMenuSoko = function(self)
		changeSubState( self, "SubMenuSoko" )
	end
}


--------------------------------
-- ダンジョン選択
--------------------------------
App.Home.MainMenu.SubMenuDungeonSelect = {
	stateWillEnter = function(self)
		
	end
}


--------------------------------
-- 倉庫選択
--------------------------------
App.Home.MainMenu.SubMenuSoko = {
	stateWillEnter = function(self)
		
	end,

	--強化を開いた際の遷移
	OnEnterEnhance = function(self)
		changeSubState( self, "Enhance" )
	end,

	--進化を開いた際の遷移
	OnEnterEvolution = function(self)
		changeSubState( self, "Evolution" )
	end,

	--伝説を開いた際の遷移
	OnEnterLegend = function(self)
		changeSubState( self, "Legend" )
	end
}


--------------------------------
-- 倉庫 → 強化を選択
--------------------------------
App.Home.MainMenu.SubMenuSoko.Enhance = {
	stateWillEnter = function(self)
		PrintLog("stateWillEnter:App.Home.MainMenu.SubMenuSoko.Enhance")
	end,

	OnEnterToEnhanceDemo = function(self,demoID)
	PrintLog("%%%%%%%%%%%%%%%%%%% 3 OnEnterToEnhanceDemo: "..demoID)
		if type( App.Home.MainMenu.SubMenuSoko.Enhance[demoID] )=="table" then
			changeSubState( self, demoID )
		else
			PrintLog("Enhance demo is not found " .. tostring(demoID))
		end
	end,

	OnEnterToIdle = function(self)
		changeSubState( self, "Idle" )
	end
}


--------------------------------
-- 倉庫 → 進化を選択
--------------------------------
App.Home.MainMenu.SubMenuSoko.Evolution = {
	stateWillEnter = function(self)
		
	end,

	OnEnterToEvolutionDemo = function(self,demoID)
	PrintLog("%%%%%%%%%%%%%%%%%%% 3 OnEnterToEvolutionDemo: "..demoID)
		if type( App.Home.MainMenu.SubMenuSoko.Evolution[demoID] )=="table" then
			changeSubState( self, demoID )
		else
			PrintLog("Evolution demo is not found " .. tostring(demoID))
		end
	end,
	
	OnEnterToIdle = function(self)
		changeSubState( self, "Idle" )
	end
}


--------------------------------
-- 倉庫 → 伝説を選択
--------------------------------
App.Home.MainMenu.SubMenuSoko.Legend = {
	stateWillEnter = function(self)
		
	end,

	OnEnterToLegendDemo = function(self,demoID)
	PrintLog("%%%%%%%%%%%%%%%%%%% 3 OnEnterToLegendDemo: "..demoID)
		if type( App.Home.MainMenu.SubMenuSoko.Legend[demoID] )=="table" then
			changeSubState( self, demoID )
		else
			PrintLog("Legend demo is not found " .. tostring(demoID))
		end
	end,
	
	OnEnterToIdle = function(self)
		changeSubState( self, "Idle" )
	end
}


