
SHOULD_OUTPUT_LOG = false

function clearSubState( state )
	state.state = nil
end

function clearState( state )
	state.parent.state = nil
end

function changeSubState( state, subStateName)

	local subState = state[subStateName]
	local sub = state.state
	
	if subState == nil or type(subState)~="table" then
		PrintLog( "substate is none " .. subStateName )
		return
	end

	if subState == sub then
		PrintLog( "ignored " .. subStateName )
		return
	end

	state.state = subState
	local prev = state
	while sub do
		if sub.stateDidLeave then
			sub:stateDidLeave()
		end
		prev = sub
		sub = sub.state
		prev.state = nil
	end

	if not subState then
		PrintLog("Lua Error!: state is nil...  check your state names!" .. subStateName)
	end

	state.prevStateName = state.currentStateName
	state.currentStateName = subStateName

	if state.currentStateName then
		PrintLog( state.currentStateName )
	end
	PrintLog( "current: " .. subStateName)
	
	subState.parent = state
	subState.state = nil

	if SHOULD_OUTPUT_LOG then
		PrintLog( "state is changed to " .. subStateName  )
	end
	if subState.stateWillEnter then
		subState:stateWillEnter()
	end
	
end

function changeState( state, subStateName )
	changeSubState( state.parent, subStateName )
end

function rewindSubState( state )
	changeSubState( state, state.prevStateName )
end

function rewindState( state )
	changeSubState( state.parent, state.parent.prevStateName )
end

subDidFunc = false

function getStatePath( s )
	local t = ""
	while s and s.currentStateName do
		t = t .. "." .. s.currentStateName
		s = s.state
	end
	return t
end

function getFullStatePath()
	return getStatePath(_G)
end

function callEvent( funcname, ... )
	subDidFunc = false
	if SHOULD_OUTPUT_LOG then
		PrintLog( "state[" .. getStatePath(_G) .."] " .. " event[" .. funcname .. "] raised")
	end
	ret = invoke( _G, funcname, ... )
--
-- for debug
--
--	if not ret then
--		PrintLog( "but disposed: " .. getStatePath(_G) )
--	end
--
--
--
	return subDidFunc
end

function invoke( self, funcname, ... )

	local func = self[funcname]
	local sub = self.state

		-- subがあるなら、そっちのinvokeでpcallされる
	if(type(func)=="function") and sub == nil then
--
-- for debug
--
	if SHOULD_OUTPUT_LOG then
		PrintLog( "catched: " .. getStatePath(_G) )
	end
--
--
--
		
--		table.insert(arg,1,self);
--		local ret = func( unpack(arg) )
		local ret = func( self, ... )
--		table.remove(arg,1);
		subDidFunc = true
		if ret then
			return ret
		end
	elseif type(func)=="string" then
		local newState = self.parent[func]
		if( newState ) then
			changeState( self, func )
			return
		else
			print("Lua Error! State dosen't exist:" .. func)
		end
	end

		-- サブ状態へディスパッチ
	if( sub ) then
		local r = {invoke( sub, funcname, ... )}
			-- 返り値があったらおしまい
		if( #r > 0 ) then return unpack( r ) end
	end

	if(type(func)=="function") and (sub and not subDidFunc) then
--		table.insert(arg,1,self);
--		local ret = func( unpack(arg) )
--		table.remove(arg,1);
		local ret = func( self, ... )
		subDidFunc = true
		if ret then
			return ret
		end
	end

end

function setState( state )

--  s = "App.Finance.BuyCoins"
	local t = _G
	for w in string.gmatch(state, "%a+") do
		if t ~= _G then
			changeSubState( t, w )
		end
		t = t[w]
	end

end
