function deepClone(t)            -- return a copy of the table t
  local new = {}             -- create a new table
  local i, v = next(t, nil)  -- i is an index of t, v = t[i]
  while i do
	if type(v) == "table" then
		new[i] = deepClone(v)
	else
		new[i] = v
	end
    i, v = next(t, i)        -- get next index
  end
  return new
end

function log(s)
	local s2 = s
	if type(s2) ~= "string" then
		s2 = tostring(s)
	end
	PrintLog(s2)
end

function logFlag()
	log(serializeFlag())
end

function split(str, delim)
    if string.find(str, delim) == nil then
        return { str }
    end

    local result = {}
    local pat = "(.-)" .. delim .. "()"
    local lastPos
    for part, pos in string.gfind(str, pat) do
        table.insert(result, part)
        lastPos = pos
    end
    table.insert(result, string.sub(str, lastPos))
    return result
end

function randomize(num)
	math.randomseed(SystemTime()+num)
end

--テキストマスターから、idを参照
function getLocalizedString(id,...)
	local args = {...}
	return ExcuteGetLocalizedString(id)
	--[[
	if args[1] ~= nil then
		return string.format(Localizedstring[id][LOCALE], ...)
	end
	return Localizedstring[id][LOCALE]
	]]--
end

